! $Id: h1parse.f90,v 1.2 2001/04/20 09:48:55 salam Exp $
program h1parse
  use types; use consts_dp
  use sub_defs_io
  use warnings_and_errors
  implicit none
  !------------------------------
  integer :: idev
  character(len=120) :: line=''
  !------------------------------
  character(len=6) :: evshp_name
  real(dp) :: res(7)
  real(dp), parameter :: Qbin_factor = 10.0_dp
  integer :: i, j, found


  evshp_name = string_val_opt('-evshp')
  if (trim(evshp_name) == 'rho_p') then
     call pscheme_read
  else
     call hzread
  end if
  

contains

  subroutine pscheme_read
    idev = get_new_device()
    open(unit=idev,file='h1-rho0.dat')
    !-- initial stuff
    do i = 1, 3
       read(idev,*)
    end do
    !-- from here it cycles
    do j = 0, 7
       do i = 1, 4
          read(idev,*)
       end do
       do i = 1, 20
          read(idev,*) res(1), res(3), res(4:6)
          res(2) = half*(res(1) + res(3))
          res(7) = res(6)
          res(4:7) = res(4:7) * Qbin_factor**j
          write(6,'(3f8.3,4es12.3)') res
       end do
       write(6,*) 
       write(6,*) 
    end do
  end subroutine pscheme_read
  

  subroutine hzread
    idev = get_new_device()
    open(unit=idev,file='hz99193dist.dat')
    found = which_key(trim(evshp_name))
    if (found == 0) call wae_error(&
         &'h1parse: could not find event shape '//trim(evshp_name))
    !-- skip lines
    do j = 0, 7
       do i = 1, 6
          read(idev,'(a)') line
       end do
       do i = 1, 10
          read(idev,*) res
          res(4:7) = res(4:7) * Qbin_factor**j
          write(6,'(3f8.3,4es12.3)') res
       end do
       write(6,*) 
       write(6,*) 
    end do
  end subroutine hzread
  

  function which_key(key1) result(res)
    character(len=*), intent(in) :: key1
    integer :: res
    integer :: iostat, ix
    
    do 
       ix = index(line, key1)
       if (ix > 0) then
          res = 1; exit
       end if
       read(idev, '(a)', iostat=iostat) line
       if (iostat /= 0) then
          res = 0; exit
       end if
    end do
  end function which_key

end program h1parse
