
program ppp
  use types; use consts_dp; use qcd
  use conv_objects; use parton_distributions; use convolution
  use pdf_representation
  use holders
  use evolution
  use alfas_server
  use sub_defs_io
  implicit none
  !-- cn = central; ot == other
  type(as_handle)  :: ashot, ashcn
  type(grid_def)   :: gd
  real(dp), pointer :: qPcnEcn(:,:), qPcnEot(:,:),qPotEot(:,:)
  real(dp), pointer :: qPcnEcn_mrs(:,:)
  integer :: iQ, id, ipdf, order
  integer :: n = 300, nQ = 50
  real(dp) :: dy, normot, normcn
  real(dp) :: Qlo, Qhi, Q, oldQ, xbj
  type(sigma_holder) :: sh

!!$  call mh_sum_rules(8.549926280_dp)
!!$  stop
  !-- message seems to be that largest-x point comes out with largest
  ! relative error (often 10-20%), for any interpolation order and 
  ! value of dy. 
  ! Not 100% understood, but sharply falling functions may be the cause.
  ! Could it be a bug? Not 100% sure.

  dy    = dble_val_opt('-dy',0.05_dp)
  order = int_val_opt('-order',3)
  !------------------------------------
  !Qlo = sqrt(1e2_dp); Qhi = sqrt(1e4_dp)
  !Qhi = 81.0_dp; Qlo = Qhi / 10.0_dp
  !Qhi = 33.0_dp; 
  xbj = dble_val_opt('-xbj')
  Qhi = dble_val_opt('-Qhi')
  Qlo = Qhi / 10.0_dp

  call qcd_SetNf(5)
  call conv_InitGridDef(gd,dy,log(one/xbj),order=order)
  call holder_InitSigma(gd, sh, factscheme_MSbar)
  !call holder_InitSigma(gd, sh, factscheme_DIS)

  write(0,*) 'Init done'

  !-- cn-alpha param and cn-alpha evln 
  call pdf_InitDist(gd,qPcnEcn,Qhi,pdf_MRS99 + 1)
  call pdf_InitDist(gd,qPotEot,Qhi,pdf_MRS99 + 5)
  call as_init(ashcn, alfas=0.1175_dp, nloop=2, fixnf=5)
  call as_init(ashot, alfas=0.1225_dp, nloop=2, fixnf=5)

  !----
  call pdf_InitDist(gd,qPcnEot,Qhi,pdf_ZERO)
  qPcnEot = qPcnEcn

  normcn = (sh%C2 .conv. qPcnEcn) .atx. (xbj .with. gd)
  normot = (sh%C2 .conv. qPotEot) .atx. (xbj .with. gd)


  do iQ = 0, nQ
     Q = Qhi * (Qlo/Qhi)**(iQ*one/nQ)
     if (iQ /= 0) then
        !call ev_evolveLO(sh%P,q1me,ash,qot, qcn)
        call ev_evolveNLO(sh%P,sh%P1, qPcnEcn, ashcn, oldQ, Q)
        call ev_evolveNLO(sh%P,sh%P1, qPcnEot, ashot, oldQ, Q)
        call ev_evolveNLO(sh%P,sh%P1, qPotEot, ashot, oldQ, Q)
     end if
     ! print tcnngs out here
     call pdf_InitDist(gd,qPcnEcn_mrs,Q,pdf_MRS99 + 1)
     write(6,'(5f18.12)') Q/Qhi, &
          &  ((sh%C2 .conv. qPcnEcn) .atx. (xbj .with. gd))/normcn,&
          &  ((sh%C2 .conv. qPcnEot) .atx. (xbj .with. gd))/normcn,&
          &  ((sh%C2 .conv. qPotEot) .atx. (xbj .with. gd))/normot,&
          &  ((sh%C2 .conv. qPcnEcn_mrs) .atx. (xbj .with. gd))/normcn
     oldQ = Q
  end do
  
end program ppp
