
program ppp
  use types; use consts_dp; 
  use conv_objects; use parton_distributions; use convolution
  use coefficient_functions; use qcd
  use evolution
  use holders
  use alfas_server
  use pdf_tabulate
  implicit none
  type(as_handle)  :: ash
  type(grid_def)   :: gd
  real(dp), pointer :: q0(:,:),q1(:,:)
  integer :: i, id, ipdf
  integer :: n = 300, nQ = 100
  real(dp) :: f, y, dy
  real(dp) :: Qbase, Qlow, Q, as2pi, xval
  real(dp), pointer :: F2(:), FL(:)
  type(sigma_holder) :: sh
  type(qtab_holder)  :: qtabh1, qtabh2, qtabh3
  type(qtab_cache)   :: qtcache

!!$  call mh_sum_rules(8.549926280_dp)
!!$  stop
  dy = 0.025_dp
  call conv_InitGridDef(gd, dy, 10.0_dp, order=2)
  call holder_InitSigma(gd, sh, factscheme_MSbar)
  
  call conv_allocgridquant(gd,F2)
  call conv_allocgridquant(gd,FL)


!!$  ipdf = pdf_MRS98LO + 1
!!$  call as_init(ash, alfas=0.125_dp, nloop=1)
!!$  ipdf = pdf_MRS99 + 1
!!$  call as_init(ash, alfas=0.1175_dp, nloop=2)
!!$  ipdf = pdf_MRS98 + 1
!!$  call as_init(ash, alfas=0.1175_dp, nloop=2)
!!$  !Qlo = sqrt(3.2e3_dp); Qhi = sqrt(3.2e4_dp)
!!$  Qlo = sqrt(1e2_dp); Qhi = sqrt(3.2e4_dp)
!!$  !call as_init(ash, alfas=0.125_dp, nloop=1)
!!$  ipdf = pdf_CTEQ5L
!!$  call as_init(ash, alfas=0.127_dp, nloop=1)
  ipdf = pdf_CTEQ5M1
  call as_init(ash, alfas=0.118_dp, nloop=2)
  !Qlo = 13.8228_dp; Qhi = 171.811_dp
  !Qlo = 6.4689_dp; Qhi = 171.811_dp

  Qbase  = 100.0_dp
  Qlow   = 1.0_dp
  as2pi = as_value(ash,Qbase) / twopi


  xval = exp(-6.8_dp)

  call pdf_InitDist(gd,q0,Qbase,ipdf)
  call pdf_InitDist(gd,q1,Qbase,ipdf)
  !-------- FOR TESTING MU_R DEPENDENCE MUST FIX NF ELSE HELL BREAKS LOOSE.
  call as_init(ash, alfas=0.01_dp, nloop=2, fixnf=5)
!!$  call ev_evolveNLO(sh%P, sh%P1, q0, ash, Qbase, two*Qbase, muR_Q=one)
!!$  call ev_evolveNLO(sh%P, sh%P1, q1, ash, Qbase, two*Qbase, muR_Q=two)
!!$  call conv_PrintGridQuant(gd, q0(:,0), q1(:,0))
!!$  STOP

  write(0,*) 'Starting evolutions'
  call qtab_InitCache(qtcache, Qlow, size=6)
  call qtab_GetQTH(qtcache, qtabh1, xval, Qbase, &
       &alfas_muR=as_value(ash,Qbase), muR = Qbase, muR_Q = one, &
       & qtabid=qtabid_evlnLO, pdf_id=ipdf, sh=sh, qdist=q0)
  call qtab_GetQTH(qtcache, qtabh2, xval, Qbase, &
       &alfas_muR=as_value(ash,Qbase*two), muR = Qbase*two, muR_Q = two,&
       & qtabid=qtabid_evlnLO, pdf_id=ipdf, sh=sh, qdist=q0)

  call qtab_InitQTAB(qtabh3, xval, Qlow, Qbase, qtabid_evlnLO,&
       &sh, q0, as_value(ash,Qbase*two), muR= Qbase*two, muR_Q = two)

!!$  call qtab_InitQTAB(qtabh2, xval, Qlow, Qbase, qtabid_evlnLO,&
!!$       &sh, q0, as_value(ash,Qbase), muR_Q = two)

  do i = 0, 100
     Q = Qlow + i * (Qbase - Qlow)/100
     !call pdf_InitDist(gd,q0,Q,ipdf)
     !F2 = (sh%C2 .conv. q0)
     write(6,'(4f20.14)') Q, qtab_Val(qtabh1,Q), qtab_Val(qtabh2,Q), &
          &qtab_Val(qtabh3,Q)
     !call conv_DelGridQuant(q0)
  end do
  
  
  stop
  !.........................................................

  call pdf_InitDist(gd,q0,Q,ipdf)
  F2 = sh%C2_1%q.conv.(sh%P1%qq.conv.q0(:,1))
  FL = sh%P1%qq.conv.(sh%C2_1%q.conv.q0(:,1))
  call conv_PrintGridQuant(gd,F2,FL)
  stop
  !.........................................................

  F2 = (sh%C2 .conv. q0) + as2pi*(sh%C2_1 .conv. q0)
  FL =                     as2pi*(sh%CL_1  .conv. q0)

  write(6,*) conv_EvalGridQuant(gd,F2,-log(0.01_dp)),&
       &     conv_EvalGridQuant(gd,FL,-log(0.01_dp)),&
       &     conv_EvalGridQuant(gd,sh%C2.conv.q0,-log(0.01_dp)),&
       &     conv_EvalGridQuant(gd,q0(:,2),-log(0.01_dp))


end program ppp
