
program ppp
  use types; use consts_dp; use qcd
  use conv_objects; use parton_distributions; use convolution
  use pdf_representation
  use holders
  use evolution
  use alfas_server
  use sub_defs_io
  implicit none
  type(as_handle)  :: ash
  type(grid_def)   :: gd
  real(dp), pointer :: q0(:,:), q1me(:,:),q1them(:,:)
  integer :: i, id, ipdf, order, lcl_nf = 5
  integer :: n = 300, nQ = 100
  real(dp) :: f, y, dy, Q2a, Q2b, Q2c, as2pi, res
  real(dp) :: Qlo, Qhi, Q
  type(sigma_holder) :: sh
  type(PMat) :: PLO, PNLO

!!$  call mh_sum_rules(8.549926280_dp)
!!$  stop
  !-- message seems to be that largest-x point comes out with largest
  ! relative error (often 10-20%), for any interpolation order and 
  ! value of dy. 
  ! Not 100% understood, but sharply falling functions may be the cause.
  ! Could it be a bug? Not 100% sure.

  dy    = dble_val_opt('-dy',0.05_dp)
  order = int_val_opt('-order',3)

  call conv_InitGridDef(gd,dy,11.5_dp,order=order)

  write(0,*) 'Init done'
!!$  ipdf = pdf_MRS98LO + 1
!!$  call as_init(ash, alfas=0.125_dp, nloop=1)
!!$  ipdf = pdf_MRS99 + 1
!!$  call as_init(ash, alfas=0.1175_dp, nloop=2)
!!$  ipdf = pdf_MRS99DIS + 1
!!$  call as_init(ash, alfas=0.1175_dp, nloop=2)
!!$  ipdf = pdf_MRS98 + 1
!!$  call as_init(ash, alfas=0.1175_dp, nloop=2)
!!$  !Qlo = sqrt(3.2e3_dp); Qhi = sqrt(3.2e4_dp)
!!$  Qlo = sqrt(1e2_dp); Qhi = sqrt(3.2e4_dp)
!!$  !call as_init(ash, alfas=0.125_dp, nloop=1)
!!$  ipdf = pdf_CTEQ5L
!!$  call as_init(ash, alfas=0.127_dp, nloop=1)
!!$  ipdf = pdf_CTEQ5M1
!!$  call as_init(ash, alfas=0.118_dp, nloop=2)
!!$  ipdf = pdf_CTEQ5M
!!$  call as_init(ash, alfas=0.118_dp, nloop=2)
!!$  ipdf = pdf_CTEQ5D
!!$  call as_init(ash, alfas=0.118_dp, nloop=2)
!!$  ipdf = pdf_CTEQ4D
!!$  call as_init(ash, alfas=0.116_dp, nloop=2)
!!$  ipdf = pdf_GRV98NLM; lcl_nf=3
!!$  call as_init(ash, alfas=0.114_dp, nloop=2)
  ipdf = pdf_GRV98NLD; lcl_nf=3
  call as_init(ash, alfas=0.114_dp, nloop=2)


  !Qlo = 13.8228_dp; Qhi = 171.811_dp
  !Qlo = 6.4689_dp; Qhi = 171.811_dp
  Qlo = sqrt(1e2_dp); Qhi = sqrt(3.2e4_dp)
  !Qlo = sqrt(1e2_dp); Qhi = sqrt(2.2e4_dp) ! for GRV
  !Qhi = sqrt(1e2_dp); Qlo = sqrt(3.2e4_dp)


  call qcd_SetNf(lcl_nf)
  !call holder_InitSigma(gd, sh, factscheme_MSbar)
  call holder_InitSigma(gd, sh, factscheme_DIS)
  


  call pdf_InitDist(gd,q0,Qlo,ipdf)
  call pdf_InitDist(gd,q1them,Qhi,ipdf)
  call pdf_InitDist(gd,q1me,Qlo,pdf_ZERO)
  q1me = q0


  call ev_evolveNLO(sh%P,sh%P1,q1me,ash,qlo, qhi)
  !call ev_evolveLO(sh%P,q1me,ash,qlo, qhi)

  !id = id_u
  id = id_d
  !call conv_PrintGridQuant(gd,q0(:,id),q1me(:,id),q1them(:,id),dy=0.2_dp)
  call conv_PrintGridQuant(gd,q0(:,id),q1me(:,id),q1them(:,id))

end program ppp
