! $Id: main-sigmaexample.f90,v 1.1 2001/04/25 10:28:40 salam Exp $
program ppp
  use types; use consts_dp; use qcd
  use conv_objects; use parton_distributions; use convolution
  use pdf_representation
  use holders
  use evolution
  use alfas_server
  use sub_defs_io
  implicit none
  type(as_handle)  :: ash
  type(grid_def)   :: gd
  real(dp), pointer :: qdist(:,:), dqdist(:,:)
  integer :: id, ipdf, order
  real(dp) :: Qval, dy, alfas
  type(sigma_holder) :: sh

!!$  call mh_sum_rules(8.549926280_dp)
!!$  stop
  !-- message seems to be that largest-x point comes out with largest
  ! relative error (often 10-20%), for any interpolation order and 
  ! value of dy. 
  ! Not 100% understood, but sharply falling functions may be the cause.
  ! Could it be a bug? Not 100% sure.

  dy    = dble_val_opt('-dy',0.1_dp)
  order = int_val_opt('-order',3)

  call qcd_SetNf(5)
  call conv_InitGridDef(gd,dy,11.5_dp,order=order)
  call holder_InitSigma(gd, sh, factscheme_MSbar)
  !call holder_InitSigma(gd, sh, factscheme_DIS)

  write(0,*) 'Init done'
  ipdf = pdf_CTEQ5M1
  call as_init(ash, alfas=0.118_dp, nloop=2)




  Qval = 91.2_dp * exp(half)
  call pdf_InitDist(gd,qdist,Qval,ipdf)
  call pdf_InitDist(gd,dqdist,Qval,pdf_ZERO)

  alfas = as_value(ash, Qval)
  ! sh%P is matrix of LO splitting function 
  ! sh%P1 is matrix of NLO splitting function 
  dqdist = (alfas/twopi) * (sh%P .conv. qdist)


  ! id_u => up+charm+top
  ! id_d => down+strange+bottom
  ! id_g => gluon
  id = id_u
  !-- col1 = y, col2 = x, col3 = x*q(x), col4 = d/dlnQ^2 x*q(x)
  call conv_PrintGridQuant(gd,qdist(:,id),dqdist(:,id))

  write(0,*) 'Gluon distribution at x = 0.001:', &
       & qdist(:,id_g) .atx. (0.001_dp .with. gd)

end program ppp
