module test1conv_helper
  use consts_dp; use types
  use convolution_communicator
  implicit none
  private

  public :: sf, pp
contains
  
  function sf(y)
    real(dp) :: y, sf
    real(dp) :: x
    x = exp(-y)

    sf = (one-x)**3 * x**(-0.2_dp)
    !sf = one
    !sf = x**(-0.2_dp)
  end function sf
  
  function pp(y) result(res)
    real(dp) :: y, res
    res = zero
    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = one
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select
  end function pp
  

end module test1conv_helper



program ppp
  use types; use consts_dp; use convolution
  use splitting_functions
  use test1conv_helper
  use integrator; use convolution_communicator
  implicit none
  type(grid_def)   :: gd
  real(dp), pointer :: qin(:), qres(:)
  type(grid_conv)   :: gc
  integer, parameter :: n=100
  real(dp) :: res(0:n,0:2)
  real(dp) :: dy_init=0.1_dp, dy, y
  integer  :: i, j
  real(dp) :: nodes(1:3) = (/zero,one,two/)

  cc_piece = cc_REAL
!!$  do i = 1,3
!!$     write(0,*) ig_PolyWeight(pp,zero,one,nodes,i,1e-7_dp)
!!$  end do
  


  do i = 0, 2
     dy = dy_init / two**i
     call conv_InitGridDef(gd,dy,n*dy_init,order=4)
     !call conv_InitGridDef(gd,dy,n*dy_init)
     

     call conv_allocgridquant(gd,qin)
     call conv_allocgridquant(gd,qres)
     call conv_InitGridQuant(gd,qin,sf)
     call conv_InitGridConv(gd,gc,sf_Pgg)
     !call conv_InitGridConv(gd,gc,pp)

     write(0,*) 'hello'
     do j = 1, 5000
        qres = gc .conv. qin
     end do
     
     !write(0,*) i, gc%conv(0,:)
     !write(0,*) i, qres(gd%ny)
     
     do j = 0, n
        y = j * dy_init
        res(j,i) = (qres).atx.(exp(-y).with.gd)
     end do
     
     call conv_DelGridQuant(qin)
     call conv_DelGridQuant(qres)
     call conv_DelGridConv(gc)
  end do
  
  do j = 0, n
     write(6,*) j*dy_init, res(j,:)
  end do
  

end program ppp
