module test2conv_helper
  use consts_dp; use types
  implicit none
  private

  public :: sf
contains
  
  function sf(y)
    real(dp) :: y, sf
    real(dp) :: x
    x = exp(-y)

    !sf = (one-x)**2 * x**(-0.2_dp)
    sf =  x**(-0.2_dp)
  end function sf
  
end module test2conv_helper



program ppp
  use types; use consts_dp; 
  use conv_objects; use convolution
  use coefficient_functions
  use holders
  use test2conv_helper
  use qcd
  implicit none
  type(grid_def)   :: gd
  real(dp), pointer :: qa(:), qPC(:), qCP(:)
  type(sigma_holder) :: sh
  type(grid_conv)   :: PC, CP
  real(dp) :: dy

  dy = 0.1_dp
  !call conv_InitGridDef(gd,dy,10.0_dp)
  call conv_InitGridDef(gd,dy,10.0_dp,order=4)
  call holder_InitSigma(gd, sh, factscheme_MSbar)

  call conv_allocgridquant(gd,qa)
  call conv_allocgridquant(gd,qPC)
  call conv_allocgridquant(gd,qCP)
  call conv_initgridquant(gd,qa,sf)

  write(0,*) 'got here'
  call conv_convconv(PC, sh%P%qq, sh%C2_1%q)
  call conv_convconv(CP, sh%C2_1%q, sh%P%qq)

  qPC = sh%P%qq .conv. (sh%C2_1%q .conv. qa)
  write(0,*) 'hello'
  qCP = sh%C2_1%q .conv. (sh%P%qq .conv. qa)

  call conv_PrintGridQuant(gd,qPC, qCP, PC .conv. qa, CP .conv. qa,dy=0.1_dp)




end program ppp
