! $Id: parton_distributions.f90,v 1.6 2001/10/19 15:10:10 salam Exp $
module parton_distributions
  use types; use consts_dp; use qcd
  use pdf_representation
  use convolution
  use assertions
  implicit none
  private

  public :: pdf_InitDist, pdf_Val

  public :: pdf_InitDistCTEQ, pdf_InitDistCTEQflav
  public :: pdf_InitDistGRV
  public :: pdf_CTEQintrfc


  integer, parameter, public :: pdf_base = 100
  integer, parameter, public :: pdf_ZERO = 0
  integer, parameter, public :: pdf_ILLEGAL = -1

  integer, parameter, public :: pdf_CTEQ5 = 1 * pdf_base
  integer, parameter, public :: pdf_CTEQ5M  = 1 + pdf_CTEQ5
  integer, parameter, public :: pdf_CTEQ5D  = 2 + pdf_CTEQ5
  integer, parameter, public :: pdf_CTEQ5L  = 3 + pdf_CTEQ5
  integer, parameter, public :: pdf_CTEQ5HJ = 4 + pdf_CTEQ5
  integer, parameter, public :: pdf_CTEQ5M1 = 8 + pdf_CTEQ5

  integer, parameter, public :: pdf_CTEQ4 = 2 * pdf_base
  integer, parameter, public :: pdf_CTEQ4M  = 1 + pdf_CTEQ4
  integer, parameter, public :: pdf_CTEQ4D  = 2 + pdf_CTEQ4

  
  integer, parameter, public :: pdf_GRV = 7 * pdf_base
  integer, parameter, public :: pdf_GRV98LO  = 1 + pdf_GRV
  integer, parameter, public :: pdf_GRV98NLM = 2 + pdf_GRV
  integer, parameter, public :: pdf_GRV98NLD = 3 + pdf_GRV
  
  integer, parameter, public :: pdf_MRS99    = 11 * pdf_base
  integer, parameter, public :: pdf_MRS99_1  = pdf_MRS99+1 
  integer, parameter, public :: pdf_MRS99_2  = pdf_MRS99+2 
  integer, parameter, public :: pdf_MRS99_3  = pdf_MRS99+3 
  integer, parameter, public :: pdf_MRS99_4  = pdf_MRS99+4 
  integer, parameter, public :: pdf_MRS99_5  = pdf_MRS99+5 
  integer, parameter, public :: pdf_MRS99_6  = pdf_MRS99+6 
  integer, parameter, public :: pdf_MRS99_7  = pdf_MRS99+7 
  integer, parameter, public :: pdf_MRS99_8  = pdf_MRS99+8 
  integer, parameter, public :: pdf_MRS99_9  = pdf_MRS99+9 
  integer, parameter, public :: pdf_MRS99_10 = pdf_MRS99+10
  integer, parameter, public :: pdf_MRS99_11 = pdf_MRS99+11
  integer, parameter, public :: pdf_MRS99_12 = pdf_MRS99+12

  integer, parameter, public :: pdf_MRS99DIS = 12 * pdf_base
  integer, parameter, public :: pdf_MRS99DIS_1  = pdf_MRS99DIS+1 
  integer, parameter, public :: pdf_MRS99DIS_2  = pdf_MRS99DIS+2 
  integer, parameter, public :: pdf_MRS99DIS_3  = pdf_MRS99DIS+3 
  integer, parameter, public :: pdf_MRS99DIS_4  = pdf_MRS99DIS+4 
  integer, parameter, public :: pdf_MRS99DIS_5  = pdf_MRS99DIS+5 
  integer, parameter, public :: pdf_MRS99DIS_6  = pdf_MRS99DIS+6 
  integer, parameter, public :: pdf_MRS99DIS_7  = pdf_MRS99DIS+7 
  integer, parameter, public :: pdf_MRS99DIS_8  = pdf_MRS99DIS+8 
  integer, parameter, public :: pdf_MRS99DIS_9  = pdf_MRS99DIS+9 
  integer, parameter, public :: pdf_MRS99DIS_10 = pdf_MRS99DIS+10
  integer, parameter, public :: pdf_MRS99DIS_11 = pdf_MRS99DIS+11
  integer, parameter, public :: pdf_MRS99DIS_12 = pdf_MRS99DIS+12

  integer, parameter, public :: pdf_MRS98    = 13 * pdf_base
  integer, parameter, public :: pdf_MRS98_1  = pdf_MRS98+1 
  integer, parameter, public :: pdf_MRS98_2  = pdf_MRS98+2 
  integer, parameter, public :: pdf_MRS98_3  = pdf_MRS98+3 
  integer, parameter, public :: pdf_MRS98_4  = pdf_MRS98+4 
  integer, parameter, public :: pdf_MRS98_5  = pdf_MRS98+5 

  integer, parameter, public :: pdf_MRS98LO  = 10 * pdf_base
  integer, parameter, public :: pdf_MRS98LO_1  = pdf_MRS98LO+1 
  integer, parameter, public :: pdf_MRS98LO_2  = pdf_MRS98LO+2 
  integer, parameter, public :: pdf_MRS98LO_3  = pdf_MRS98LO+3 
  integer, parameter, public :: pdf_MRS98LO_4  = pdf_MRS98LO+4 
  integer, parameter, public :: pdf_MRS98LO_5  = pdf_MRS98LO+5 

  integer, parameter, public :: pdf_MRST2001 = 14 * pdf_base
  integer, parameter, public :: pdf_MRST2001_1 = pdf_MRST2001+1
  integer, parameter, public :: pdf_MRST2001_2 = pdf_MRST2001+2
  integer, parameter, public :: pdf_MRST2001_3 = pdf_MRST2001+3
  integer, parameter, public :: pdf_MRST2001_4 = pdf_MRST2001+4
  
  !-- x^{-om), with om=1.0 in the g and q channels
  !   NB: do not change the 10g and 10q identifiers. They are
  !       used (exploiting their numerical values) later.
  integer, parameter, public :: pdf_POWER     = 30 * pdf_base
  integer, parameter, public :: pdf_POWER10g  = 1 + pdf_POWER
  integer, parameter, public :: pdf_POWER10q  = 2 + pdf_POWER
  integer, parameter, public :: pdf_POWER04g  = 3 + pdf_POWER
  integer, parameter, public :: pdf_POWER04q  = 4 + pdf_POWER

  real(dp) :: pdf_Q2, pdf_Q
  integer  :: pdf_iflav, pdf_iset, pdf_igrp
  logical, save :: firstCTEQ = .true.


  !-- temp --
  public :: pdf_Q, pdf_MRSintrfc
contains

  
  !-----------------------------------------------------------------
  ! In general this is nice to have. For now cannot see how to have
  ! an efficient general routine that can fulfill both this function and 
  ! that of pdf_InitDist (problem is that of avoiding rewriting the choice
  ! of pdf part)
  function pdf_Val(xval, Qval,iset) result(res)
    real(dp), intent(in) :: xval, Qval
    integer,  intent(in) :: iset
    real(dp)             :: res(0:ncomponents)
    !---------------------------------------
    real(dp)             :: yval
    
    yval = log(one/xval)
    pdf_Q2 = Qval**2
    pdf_Q  = Qval
    pdf_iset = mod(iset,pdf_base)
    pdf_igrp = pdf_base * (iset/pdf_base)

    !write(0,*) pdf_igrp, pdf_MRS98LO
    select case (pdf_igrp)
    case(pdf_CTEQ5)
       call SetCtq5(pdf_iset)
       res = pdf_CTEQintrfc(yval,ncomponents+1)
    case(pdf_CTEQ4)
       write(0,*) 'pdf_CTEQ4 is not supported at the moment, due to naming conflicts'
       stop
       !call SetCtq4(pdf_iset)
       !res = pdf_CTEQ4intrfc(yval,ncomponents+1)
       !res = pdf_CTEQ4paramintrfc(yval,ncomponents+1)
    case(pdf_GRV)
       res = pdf_GRVintrfc(yval,ncomponents+1)
    case(pdf_MRS98LO, pdf_MRS99, pdf_MRS99DIS, pdf_MRS98, pdf_MRST2001)
       res = pdf_MRSintrfc(yval,ncomponents+1)
    case(pdf_POWER)
       res = pdf_POWERintrfc(yval,ncomponents+1)
    case(pdf_ZERO)
       res = zero
    case default
       write(0,*) 'Unsupported pdf set:', iset,'.  PDF set to zero'
       res = zero
    end select
  end function pdf_Val
  
  
  !----------------------------------------------------------------------
  ! it is almost like reinventing the wheel in so far as pdflib has
  ! already done the work -- but they seem to be a bit on the slow side
  subroutine pdf_InitDist(gd,q,Qval,iset)
    type(grid_def), intent(in) :: gd
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: Qval
    integer,        intent(in) :: iset

    call conv_AllocGridQuant(gd,q,0,ncomponents)
    pdf_Q2 = Qval**2
    pdf_Q  = Qval
    pdf_iset = mod(iset,pdf_base)
    pdf_igrp = pdf_base * (iset/pdf_base)

    !write(0,*) pdf_igrp, pdf_MRS98LO
    select case (pdf_igrp)
    case(pdf_CTEQ5)
       call SetCtq5(pdf_iset)
       call conv_InitGridQuant(gd,q,pdf_CTEQintrfc)
    case(pdf_CTEQ4)
       write(0,*) 'pdf_CTEQ4 is not supported at the moment, due to naming conflicts'
       stop
       !call SetCtq4(pdf_iset)
       !call conv_InitGridQuant(gd,q,pdf_CTEQ4intrfc)
       !call conv_InitGridQuant(gd,q,pdf_CTEQ4paramintrfc)
    case(pdf_GRV)
       call conv_InitGridQuant(gd,q,pdf_GRVintrfc)
    case(pdf_MRS98LO, pdf_MRS99, pdf_MRS99DIS, pdf_MRS98, pdf_MRST2001)
       call conv_InitGridQuant(gd,q,pdf_MRSintrfc)
    case(pdf_POWER)
       call conv_InitGridQuant(gd,q,pdf_POWERintrfc)
    case(pdf_ZERO)
       q = zero
    case default
       write(0,*) 'Unsupported pdf set:', iset,'.  PDF set to zero'
       q = zero
    end select
  end subroutine pdf_InitDist
  


  !----------------------------------------------------------------------
  subroutine pdf_InitDistCTEQ(gd,q,Qval,iset)
    type(grid_def), intent(in) :: gd
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: Qval
    integer,        intent(in) :: iset

    call conv_AllocGridQuant(gd,q,0,ncomponents)
    pdf_Q2 = Qval**2
    pdf_Q  = Qval
    call SetCtq5(mod(iset,pdf_base))
    call conv_InitGridQuant(gd,q,pdf_CTEQintrfc)
  end subroutine pdf_InitDistCTEQ
  

  !------------------------------------------------------------------
  function pdf_CTEQintrfc(y,n) result(res)
    real(dp), intent(in) :: y
    integer,  intent(in) :: n
    real(dp)             :: res(0:n-1)
    real(dp)             :: Ctq5Pdf
    logical  :: first=.true.
    integer  :: i
    real(dp) :: x
    i = assert_eq(n, ncomponents+1,'pdf_CTEQintrfc')
    
    if (firstCTEQ) then
       write(0,*) 'Warning: CTEQ may have been modified to have a higher &
            &degree of interpolation'
       firstCTEQ = .false.
    end if

    x = exp(-y)
    res(id_g) = Ctq5Pdf(0,x,pdf_Q)
    res(id_u) = zero
    res(id_d) = zero

    if (nf /= 5 .and. first) then
       write(0,*) 'Warning: running CTEQ partons with nf/=5'
       first = .false.
    end if
      
    do i = -1,1,2
       res(id_u) = res(id_u) + Ctq5Pdf(i*1,x,pdf_Q)&
            &                + Ctq5Pdf(i*4,x,pdf_Q)
       res(id_d) = res(id_d) + Ctq5Pdf(i*2,x,pdf_Q)&
            &                + Ctq5Pdf(i*3,x,pdf_Q)&
            &                + Ctq5Pdf(i*5,x,pdf_Q)
       !res(1) = (1-x)**4*(one + 0.1_dp*x**(-1.5_dp))
    end do
    res = res * x
  end function pdf_CTEQintrfc


  !------------------------------------------------------------------
  !NOTUSED function pdf_CTEQ4intrfc(y,n) result(res)
  !NOTUSED   real(dp), intent(in) :: y
  !NOTUSED   integer,  intent(in) :: n
  !NOTUSED   real(dp)             :: res(0:n-1)
  !NOTUSED   real(dp)             :: Ctq4Pdf
  !NOTUSED   logical  :: first=.true.
  !NOTUSED   integer  :: i
  !NOTUSED   real(dp) :: x
  !NOTUSED   i = assert_eq(n, ncomponents+1,'pdf_CTEQintrfc')
  !NOTUSED   x = exp(-y)
  !NOTUSED   res(id_g) = Ctq4Pdf(0,x,pdf_Q)
  !NOTUSED   res(id_u) = zero
  !NOTUSED   res(id_d) = zero
  !NOTUSED   do i = -1,1,2
  !NOTUSED      res(id_u) = res(id_u) + Ctq4Pdf(i*1,x,pdf_Q)&
  !NOTUSED           &                + Ctq4Pdf(i*4,x,pdf_Q)
  !NOTUSED      res(id_d) = res(id_d) + Ctq4Pdf(i*2,x,pdf_Q)&
  !NOTUSED           &                + Ctq4Pdf(i*3,x,pdf_Q)&
  !NOTUSED           &                + Ctq4Pdf(i*5,x,pdf_Q)
  !NOTUSED   end do
  !NOTUSED   res = res * x
  !NOTUSED end function pdf_CTEQ4intrfc



  !-------------------------------------------------------------
  ! to be used for parameterized version
  !NOTUSED function pdf_CTEQ4paramintrfc(y,n) result(res)
  !NOTUSED   real(dp), intent(in) :: y
  !NOTUSED   integer,  intent(in) :: n
  !NOTUSED   real(dp)             :: res(0:n-1)
  !NOTUSED   integer  :: i, irt
  !NOTUSED   real(dp) :: x, cteq_res(-6:6)
  !NOTUSED   i = assert_eq(n, ncomponents+1,'pdf_CTEQintrfc')
  !NOTUSED   x = exp(-y)
  !NOTUSED   call Ctq4Pds(pdf_iset, cteq_res, x, pdf_Q, Irt)
  !NOTUSED   res(id_g) = cteq_res(0)
  !NOTUSED   res(id_u) = cteq_res(1) + cteq_res(-1)&
  !NOTUSED        &     +cteq_res(4) + cteq_res(-4)
  !NOTUSED   res(id_d) = cteq_res(2) + cteq_res(-2)&
  !NOTUSED        &     +cteq_res(3) + cteq_res(-3)&
  !NOTUSED        &     +cteq_res(5) + cteq_res(-5)
  !NOTUSED end function pdf_CTEQ4paramintrfc
  


  !----------------------------------------------------------------------
  subroutine pdf_InitDistCTEQflav(gd,q,Qval,iset,iflav)
    type(grid_def), intent(in) :: gd
    real(dp),       pointer    :: q(:)
    real(dp),       intent(in) :: Qval
    integer,        intent(in) :: iset,iflav

    call conv_AllocGridQuant(gd,q)
    pdf_Q2 = Qval**2
    pdf_Q  = Qval
    pdf_iflav = iflav
    call SetCtq5(mod(iset,pdf_base))
    call conv_InitGridQuant(gd,q,pdf_CTEQintrfcFlav)
  end subroutine pdf_InitDistCTEQflav

  !------------------------------------------------------------------
  function pdf_CTEQintrfcFlav(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: Ctq5Pdf
    real(dp) :: x
    
    if (firstCTEQ) then
       write(0,*) 'Warning: CTEQ has been modified to have a higher &
            &degree of interpolation'
       firstCTEQ = .false.
    end if

    x = exp(-y)
    res = Ctq5Pdf(pdf_iflav,x,pdf_Q)
    res = res * x
  end function pdf_CTEQintrfcFlav



  !----------------------------------------------------------------------
  subroutine pdf_InitDistGRV(gd,q,Qval,iset)
    type(grid_def), intent(in) :: gd
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: Qval
    integer,        intent(in) :: iset

    call conv_AllocGridQuant(gd,q,0,ncomponents)
    pdf_Q2 = Qval**2
    pdf_Q  = Qval
    pdf_iset = mod(iset,pdf_base)
    call conv_InitGridQuant(gd,q,pdf_GRVintrfc)
  end subroutine pdf_InitDistGRV
  

  !------------------------------------------------------------------
  function pdf_GRVintrfc(y,n) result(res)
    real(dp), intent(in) :: y
    integer,  intent(in) :: n
    real(dp)             :: res(0:n-1)
    real(dp)             :: Ctq5Pdf
    integer  :: i
    real(dp) :: x, uv, dv, us, ds, ss, gl
    i = assert_eq(n, ncomponents+1,'pdf_GRVintrfc')
    
    !i = assert_eq(nint(nf), 3, 'pdf_GRVintrfc requires 3 active flavours')

    x = exp(-y)
    call GRV98PA(pdf_iset,x,pdf_Q2, uv, dv, us, ds, ss, gl)
    res(id_g) = gl
    res(id_u) = uv+two*us
    res(id_d) = dv+two*ds + two*ss

    !-- seems not to be wanted for GRV...
    !res = res * x
  end function pdf_GRVintrfc


  !------------------------------------------------------------------
  function pdf_MRSintrfc(y,n) result(res)
    real(dp), intent(in) :: y
    integer,  intent(in) :: n
    real(dp)             :: res(0:n-1)
    real(dp)             :: Ctq5Pdf
    integer  :: i
    real(dp) :: x, uv, dv, us, ds, ss, cs, bs, gl
    i = assert_eq(n, ncomponents+1,'pdf_MRSintrfc')
    
    !i = assert_eq(nint(nf), 5, 'pdf_MRSintrfc requires 5 active flavours')

    !write(0,*) 'hello'
    x = exp(-y)
    select case(pdf_igrp)
    case(pdf_MRS98LO)
       call mrslo98(x,pdf_Q, pdf_iset, uv, dv, us, ds, ss, cs, bs, gl)
    case(pdf_MRS99)
       call mrs99(x,pdf_Q, pdf_iset, uv, dv, us, ds, ss, cs, bs, gl)
    case(pdf_MRS99DIS)
       call mrs99dis(x,pdf_Q, pdf_iset, uv, dv, us, ds, ss, cs, bs, gl)
    case(pdf_MRS98)
       call mrs98(x,pdf_Q, pdf_iset, uv, dv, us, ds, ss, cs, bs, gl)
    case(pdf_MRST2001)
       call mrst2001(x,pdf_Q, pdf_iset, uv, dv, us, ds, ss, cs, bs, gl)
    case default
       write(0,*) 'Illegal MRS pdf set'   
    end select
    res(id_g) = gl
    res(id_u) = uv+two*(us + cs)
    res(id_d) = dv+two*(ds + ss + bs)

    res = res
  end function pdf_MRSintrfc


  !------------------------------------------------------------------
  function pdf_POWERintrfc(y,n) result(res)
    real(dp), intent(in) :: y
    integer,  intent(in) :: n
    real(dp)             :: res(0:n-1)
    real(dp) :: x, omega
    
    res = zero
    x = exp(-y)
    select case(pdf_igrp+pdf_iset)
    case(pdf_POWER10q)
       omega = one
       res(id_d) = x**(-omega) * (1 - x**2)**2
    case(pdf_POWER10g)
       omega = one
       res(id_g) = x**(-omega) * (1 - x**2)**2
       res(id_d) = res(id_g) * 1e-40_dp
    case(pdf_POWER04q)
       omega = 0.4_dp
       res(id_d) = x**(-omega) * (1 - x**2)**2
    case(pdf_POWER04g)
       omega = 0.4_dp
       res(id_g) = x**(-omega) * (1 - x**2)**2
       res(id_d) = res(id_g) * 1e-40_dp
    case default
       write(0,*) 'Illegal POWER pdf set',pdf_igrp+pdf_iset
    end select
  end function pdf_POWERintrfc
  
end module parton_distributions
