!======================================================================
!
! OBSOLETE MODULE
! OBSOLETE MODULE
! OBSOLETE MODULE
! OBSOLETE MODULE
! OBSOLETE MODULE
! OBSOLETE MODULE
! OBSOLETE MODULE
! 
! FUNCTIONALITY SUBSUMED BY RESUMMED_RESULTS?
!
! $Id: resummation.f90,v 1.3 2001/04/22 13:33:44 salam Exp $
!======================================================================

!======================================================================
! Contains resummed expressions for the event-shapes
! Will it also be partially responsible for the matching?
!======================================================================

module resummation
  use types; use consts_dp; use qcd
  implicit none
  private

  real(dp) :: oneml, onem2l, ln1ml, ln1m2l
  real(dp) :: last_lambda = -1e90_dp


  public :: rsm_sigma
  public :: rsm_FullPieces, rsm_UpperPieces

contains
  
  !---------------------------------------------------------------
  ! Eqs. C.9 and C.10c from ADS
  subroutine rsm_FullPieces(lambda, R1, R2, Rp)
    use qcd
    real(dp), intent(in)  :: lambda
    real(dp), intent(out) :: R1, R2, Rp
    
    if (lambda /= last_lambda) then
       oneml  = one - lambda
       onem2l = one - two * lambda
       ln1ml  = log(oneml)
       ln1m2l = log(onem2l)
       last_lambda = lambda
    end if

    R1 = cf/(twopi_beta0*lambda) * (onem2l*ln1m2l - two*oneml*ln1ml)
    R2 = 1.5_dp*(cf/twopi_beta0) * ln1ml + &
         & cmw_K*cf*(two*ln1ml - ln1m2l)/(twopi_beta0**2) + &
         & cf*beta1/(twopi*beta0**3) &
         &       * (ln1m2l - two*ln1ml + half*ln1m2l**2 - ln1ml**2)
    Rp = cf/(pi*beta0) * (ln1ml - ln1m2l)
  end subroutine rsm_FullPieces


  !---------------------------------------------------------------
  ! Eqs. C.7 and C.10a from ADS
  subroutine rsm_UpperPieces(lambda, RU1, RU2, RUp)
    real(dp), intent(in)  :: lambda
    real(dp), intent(out) :: RU1, RU2, RUp
    
    if (lambda /= last_lambda) then
       oneml  = one - lambda
       onem2l = one - two * lambda
       ln1ml  = log(oneml)
       ln1m2l = log(onem2l)
       last_lambda = lambda
    end if
    
    RU1 = cf/(twopi_beta0*lambda) * (-lambda -ln1ml)
    RU2 = 1.5_dp*(cf/twopi_beta0) * ln1ml +&
         &cmw_K*cf*(lambda + oneml*ln1ml)/(twopi_beta0**2*oneml) + &
         &cf*beta1/(twopi*beta0**3) * &
         &     ( -(lambda + ln1ml)/oneml - half*ln1ml**2)
    RUp = cf/twopi_beta0 * lambda/oneml
  end subroutine rsm_UpperPieces
  

  !---------------------------------------------------------------
  ! Return the integrated distribution 
  function rsm_sigma(mh, alphas, var) result(sigma)
    use matching; use event_shapes; use special_functions
    type(match_holder), intent(in)  :: mh
    real(dp),           intent(in)  :: alphas, var
    real(dp)                        :: sigma
    !--------------------------------------------------------
    real(dp) :: L, L_in, lambda, as2pi
    real(dp) :: R1, R2, Rp, RU1, RU2, RUp
    real(dp) :: sigmaR_1, sigmaR_2
    real(dp) :: pure_qrsmd

    if (mh%norm /= one) stop 'ERROR in rsm_sigma: mh%norm must be = 1'

    !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    !    WARNING
    !               L as defined here is not the same L_in as used 
    !               ma_GetSigmas (which does its own rescaling)
    !
    !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    L_in = -log( var ) 
    L = L_in + mh%log_rescale
    !L = log(mh%rescale / var )
    lambda = beta0 * alphas * L
    as2pi  = alphas / twopi

    select case (mh%id)
    case(EvshpId_rho_E)
       call rsm_FullPieces(lambda, R1, R2, Rp)
       pure_qrsmd = exp(-(L*R1 + R2) - eulergamma * Rp) / gamma(one + Rp)
       sigma = (one + as2pi*mh%C2L_1) * pure_qrsmd  &
            &   +  as2pi * mh%CCA2L_1 * exp(-(L*R1)*ca/cf)


!!$       sigma = (one + as2pi*mh%C2L_1)&
!!$            & * exp(  as2pi*(mh%G12*L**2 + mh%G11*L)&
!!$            &       + as2pi**2*(mh%G23*L**3 + mh%G22*L**2))&
!!$            & +as2pi* mh%CCA2L_1 * exp(as2pi*mh%GCA12*L**2)
       !-- remember the exact matching & the note above about def of L
       ! TEMPORARY BIT HERE...
       call ma_GetSigmas(mh, L_in, sigmaR_1, sigmaR_2)
       sigma = sigma - (one + as2pi * sigmaR_1 + as2pi**2 * sigmaR_2)
       


    case default
       write(0,*) 'ERROR in rsm_sigma: unsupported esid:', mh%id
    end select
    
  end function rsm_sigma
  
end module resummation
