!======================================================================
! A collection of special functions -- currently taken from CERNLIB (GPL
! with restriction that military use is forbidden). Collection curently
! very limited.
!
! Does not follow the coding conventions set out for the disresum package.
!
! $Id: special_functions.f90,v 1.7 2001/07/23 15:50:24 salam Exp $
module special_functions
  private
  
  public :: ddilog, dpsipg, dgamma, tanh


  !--------------------------------------------
  ! want them accessible with simpler names?
  interface gamma
     module procedure dgamma
  end interface
  interface lngamma
     module procedure dlgama
  end interface
  interface dilog
     module procedure ddilog
  end interface
  public :: dilog, gamma, lngamma
  public :: psi
  

contains


  !----------------------------------------------------------------------
  ! Will need it often
  function psi(x,k)
    use types
    implicit none
    real(dp) :: psi
    real(dp), intent(in) :: x
    integer, intent(in), optional :: k
    !----------------------------------------------------------------------
    integer :: k_local
    if (present(k)) then
       k_local = k
    else
       k_local = 0
    end if
    psi = dpsipg(x,k_local)
  end function psi




!======================================================================
! BELOW: the cernlib codes converted to f90
!======================================================================
  
  !-- DDILOG aka C332 -------------------------------------
  FUNCTION DDILOG(X) 
! 1 "gen/imp64.inc" 1                                                   
!                                                                       
! imp64.inc                                                             
!                                                                       
                                                                        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
! 12 "dilog64.F" 2                                                      
                                                                        
      DIMENSION C(0:19) 
                                                                        
      PARAMETER (Z1 = 1, HF = Z1/2) 
      PARAMETER (PI = 3.14159265358979324D0) 
      PARAMETER (PI3 = PI**2/3, PI6 = PI**2/6, PI12 = PI**2/12) 
                                                                        
      DATA C( 0) / 0.4299669356813697D0/ 
      DATA C( 1) / 0.4097598753077105D0/ 
      DATA C( 2) /-0.0185884366014592D0/ 
      DATA C( 3) / 0.0014575108062268D0/ 
      DATA C( 4) /-0.0001430418442340D0/ 
      DATA C( 5) / 0.0000158841541880D0/ 
      DATA C( 6) /-0.0000019078959387D0/ 
      DATA C( 7) / 0.0000002419180854D0/ 
      DATA C( 8) /-0.0000000319341274D0/ 
      DATA C( 9) / 0.0000000043545063D0/ 
      DATA C(10) /-0.0000000006578480D0/ 
      DATA C(11) / 0.0000000000612098D0/ 
      DATA C(12) /-0.0000000000244332D0/ 
      DATA C(13) / 0.0000000000182256D0/ 
      DATA C(14) /-0.0000000000027007D0/ 
      DATA C(15) / 0.0000000000004042D0/ 
      DATA C(16) /-0.0000000000000610D0/ 
      DATA C(17) / 0.0000000000000093D0/ 
      DATA C(18) /-0.0000000000000014D0/ 
      DATA C(19) /+0.0000000000000002D0/ 
                                                                        
      IF(X .EQ. 1) THEN 
       H=PI6 
      ELSEIF(X .EQ. -1) THEN 
       H=-PI12 
      ELSE 
       T=-X 
       IF(T .LE. -2) THEN 
        Y=-1/(1+T) 
        S=1 
        A=-PI3+HF*(LOG(-T)**2-LOG(1+1/T)**2) 
       ELSEIF(T .LT. -1) THEN 
        Y=-1-T 
        S=-1 
        A=LOG(-T) 
        A=-PI6+A*(A+LOG(1+1/T)) 
       ELSE IF(T .LE. -HF) THEN 
        Y=-(1+T)/T 
        S=1 
        A=LOG(-T) 
        A=-PI6+A*(-HF*A+LOG(1+T)) 
       ELSE IF(T .LT. 0) THEN 
        Y=-T/(1+T) 
        S=-1 
        A=HF*LOG(1+T)**2 
       ELSE IF(T .LE. 1) THEN 
        Y=T 
        S=1 
        A=0 
       ELSE 
        Y=1/T 
        S=-1 
        A=PI6+HF*LOG(T)**2 
       ENDIF 
       H=Y+Y-1 
       ALFA=H+H 
       B1=0 
       B2=0 
       DO I = 19,0,-1 
          B0=C(I)+ALFA*B1-B2 
          B2=B1 
          B1=B0 
       END DO
       H=-(S*(B0-H*B2)+A) 
      ENDIF 
                                                                        
      DDILOG=H 
      RETURN 
      END  FUNCTION DDILOG


!======================================================================
! $Id: special_functions.f90,v 1.7 2001/07/23 15:50:24 salam Exp $           
!                                                                       
!                                                                       
!                                                                       
      FUNCTION DGAMMA(X) 
!                                                                       
!                                                                       
!                                                                       
! imp64.inc                                                             
!                                                                       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
!                                                                       
      CHARACTER*(*) NAME 
      PARAMETER(NAME='GAMMA/DGAMMA') 
!                                                                       
      CHARACTER*80 ERRTXT 
                                                                        
      DIMENSION C(0:15) 
                                                                        
      DATA C( 0) /3.65738772508338244D0/ 
      DATA C( 1) /1.95754345666126827D0/ 
      DATA C( 2) /0.33829711382616039D0/ 
      DATA C( 3) /0.04208951276557549D0/ 
      DATA C( 4) /0.00428765048212909D0/ 
      DATA C( 5) /0.00036521216929462D0/ 
      DATA C( 6) /0.00002740064222642D0/ 
      DATA C( 7) /0.00000181240233365D0/ 
      DATA C( 8) /0.00000010965775866D0/ 
      DATA C( 9) /0.00000000598718405D0/ 
      DATA C(10) /0.00000000030769081D0/ 
      DATA C(11) /0.00000000001431793D0/ 
      DATA C(12) /0.00000000000065109D0/ 
      DATA C(13) /0.00000000000002596D0/ 
      DATA C(14) /0.00000000000000111D0/ 
      DATA C(15) /0.00000000000000004D0/ 
                                                                        
      U=X 
      IF(U .LE. 0) THEN 
       WRITE(ERRTXT,101) U 
       CALL MTLPRT(NAME,'C302.1',ERRTXT) 
       H=0 
       GO TO 9 
      ENDIF 
    8 F=1 
      IF(U .LT. 3) THEN 
       DO 1 I = 1,INT(4-U) 
       F=F/U 
    1  U=U+1 
      ELSE 
       DO 2 I = 1,INT(U-3) 
       U=U-1 
    2  F=F*U 
      END IF 
      H=U+U-7 
      ALFA=H+H 
      B1=0 
      B2=0 
      DO 3 I = 15,0,-1 
      B0=C(I)+ALFA*B1-B2 
      B2=B1 
    3 B1=B0 
                                                                        
    9 DGAMMA=F*(B0-H*B2) 
                                                                        
      RETURN 
  101 FORMAT('ARGUMENT IS NEGATIVE = ',1P,E15.1) 
      END FUNCTION DGAMMA                                



      !=====================================================================
      ! $Id: special_functions.f90,v 1.7 2001/07/23 15:50:24 salam Exp $          
      !
      ! Revision 1.1.1.1  1996/04/01 15:01:54  mclareni                       
      ! Mathlib gen                                                           
      !
      !
      FUNCTION DLGAMA(X)
        IMPLICIT DOUBLE PRECISION (A-H,O-Z) 

        CHARACTER*(*) NAME
        PARAMETER(NAME='ALGAMA/DLGAMA')
        DIMENSION P1(7),Q1(7),P2(7),Q2(7),P3(7),Q3(7),C(5)

        PARAMETER (Z1 = 1, HF = Z1/2, HF1 = 1+HF)
        CHARACTER*80 ERRTXT
        DATA P1                                                           &
             &/+3.842873656745991D+0, +5.270689375300983D+1,&
             & +5.558404572351531D+1, -2.151351357372570D+2,&
             & -2.458726172229242D+2, -5.750089360304123D+1, &
             & -2.335909894951284D+0/              
        DATA Q1 &                                  
             &/+1.000000000000000D+0, +3.373304790707074D+1, &
             & +1.938778403437713D+2, +3.088295497342428D+2, &
             & +1.500683906489095D+2, +2.010685134433395D+1, &
             & +4.571742028250299D-1/
        DATA P2                                                         &
             &/+4.8740201396838636D+0, +2.4884525168574076D+2, &
             & +2.1797366058895915D+3, +3.7975124011525118D+3, &
             & -1.9778070769841646D+3, -3.6929834005591282D+3, &
             & -5.6017773537803877D+2/                   
        DATA Q2                                                     &
             &/+1.0000000000000000D+0, +9.5099917418208938D+1, &
             & +1.5612045277928635D+3, +7.2340087928948071D+3, &
             & +1.0459576594058959D+4, +4.1699415153200231D+3, &
             & +2.7678583623804101D+2/
        DATA P3                                                         &
             &/-6.880624009459425D+3, -4.306996981957098D+5, &
             & -4.750459465343956D+6, -2.942344593032234D+6, &
             & +3.632180493154257D+7, -3.356778281454576D+6, &
             & -2.480436948828593D+7/              
        DATA Q3                                                       &
             &/+1.000000000000000D+0, -1.421682983965146D+3, &
             & -1.555289028085353D+5, -3.415251710801107D+6, &
             & -2.096962325580444D+7, -3.454417509334395D+7, &
             & -9.160558286371317D+6/
        DATA C                                                          &
             &/ 1.1224921356561D-1,  7.9591692961204D-2, &
             & -1.7087794611020D-3,  9.1893853320467D-1, &
             &  1.3469905627879D+0/


        IF(X .LE. 0) THEN
         H=0
         WRITE(ERRTXT,101) X
         CALL MTLPRT(NAME,'C304.1',ERRTXT)
        ELSE IF(X .EQ. 1 .OR. X .EQ. 2) THEN
         H=0
        ELSE IF(X .LE. HF) THEN
         Y=X+1
         AP=P1(1)
         AQ=Q1(1)
         DO 2 I = 2,7
         AP=P1(I)+Y*AP
      2  AQ=Q1(I)+Y*AQ
         H=-LOG(X)+X*AP/AQ
        ELSE IF(X .LE. HF1) THEN
         AP=P1(1)
         AQ=Q1(1)
         DO 3 I = 2,7
         AP=P1(I)+X*AP
      3  AQ=Q1(I)+X*AQ
         H=(X-1)*AP/AQ
        ELSE IF(X .LE. 4) THEN
         AP=P2(1)
         AQ=Q2(1)
         DO 4 I = 2,7
         AP=P2(I)+X*AP
      4  AQ=Q2(I)+X*AQ
         H=(X-2)*AP/AQ
        ELSE IF(X .LE. 12) THEN
         AP=P3(1)
         AQ=Q3(1)
         DO 5 I = 2,7
         AP=P3(I)+X*AP
      5  AQ=Q3(I)+X*AQ
         H=AP/AQ
        ELSE
         Y=1/X**2
         H=(X-HF)*LOG(X)-X+C(4)+(C(1)+Y*(C(2)+Y*C(3)))/                   &
       &                                        ((C(5)+Y)*X)
        ENDIF
        DLGAMA=H
        RETURN
    101 FORMAT('NON-POSITIVE ARGUMENT  X = ',1P,E15.6)
  END FUNCTION DLGAMA








!======================================================================
!
      FUNCTION dpsipg(X,K)
!
!
! $Id: special_functions.f90,v 1.7 2001/07/23 15:50:24 salam Exp $
!
!
! imp64.inc
!

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
!
      CHARACTER*(*) NAME
      PARAMETER(NAME='RPSIPG/dpsipg')
!
      DIMENSION B(0:20,6),C(7,6),NB(6),P1(0:7),Q1(0:7),P2(0:4),Q2(0:4)
      DIMENSION SGN(6),SGF(0:6),SGH(6)

      PARAMETER (DELTA = 1D-13)
      PARAMETER (Z1 = 1, HF = Z1/2)
      PARAMETER (PI = 3.14159265358979324D0)
      PARAMETER (C1 = -PI**2, C2 = 2*PI**3, C3 = 2*PI**4)
      PARAMETER (C4 = -8*PI**5, C5 = -8*PI**6, C6 = 16*PI**7)

      CHARACTER*80 ERRTXT

      DATA NB /16,17,17,18,19,20/
      DATA SGN /-1,1,-1,1,-1,1/, SGF /1,-1,2,-6,24,-120,720/
      DATA SGH /-0.5D0,1,-3,12,-60,360/
      DATA X0 /1.46163214496836234D0/

      DATA (P1(J),Q1(J),J=0,7)                                          &
     &/ 1.35249996677263464D+4, 6.93891117537634444D-7, &
     &  4.52856016995472897D+4, 1.97685742630467364D+4, &
     &  4.51351684697366626D+4, 4.12551608353538323D+4, &
     &  1.85290118185826102D+4, 2.93902871199326819D+4, &
     &  3.32915251494069355D+3, 9.08196660748551703D+3, &
     &  2.40680324743572018D+2, 1.24474777856708560D+3, &
     &  5.15778920001390847D+0, 6.74291295163785938D+1, &
     &  6.22835069189847458D-3, 1/

      DATA (P2(J),Q2(J),J=0,4)                                          &
     &/-2.72817575131529678D-15,7.77788548522961604D+0, &
     & -6.48157123766196510D-1, 5.46117738103215070D+1, &
     & -4.48616543918019358D+0, 8.92920700481861370D+1, &
     & -7.01677227766758664D+0, 3.22703493791143361D+1, &
     & -2.12940445131010517D+0, 1/

      DATA B( 0,1) / 0.334838697910949386D0/
      DATA B( 1,1) /-0.055187482048730095D0/
      DATA B( 2,1) / 0.004510190736011502D0/
      DATA B( 3,1) /-0.000365705888303721D0/
      DATA B( 4,1) / 0.000029434627468223D0/
      DATA B( 5,1) /-0.000002352776815151D0/
      DATA B( 6,1) / 0.000000186853176633D0/
      DATA B( 7,1) /-0.000000014750720184D0/
      DATA B( 8,1) / 0.000000001157993337D0/
      DATA B( 9,1) /-0.000000000090439179D0/
      DATA B(10,1) / 0.000000000007029627D0/
      DATA B(11,1) /-0.000000000000543989D0/
      DATA B(12,1) / 0.000000000000041925D0/
      DATA B(13,1) /-0.000000000000003219D0/
      DATA B(14,1) / 0.000000000000000246D0/
      DATA B(15,1) /-0.000000000000000019D0/
      DATA B(16,1) / 0.000000000000000001D0/

      DATA B( 0,2) /-0.112592935345473830D0/
      DATA B( 1,2) / 0.036557001742820941D0/
      DATA B( 2,2) /-0.004435942496027282D0/
      DATA B( 3,2) / 0.000475475854728926D0/
      DATA B( 4,2) /-0.000047471836382632D0/
      DATA B( 5,2) / 0.000004521815237353D0/
      DATA B( 6,2) /-0.000000416300079620D0/
      DATA B( 7,2) / 0.000000037338998165D0/
      DATA B( 8,2) /-0.000000003279914474D0/
      DATA B( 9,2) / 0.000000000283211377D0/
      DATA B(10,2) /-0.000000000024104028D0/
      DATA B(11,2) / 0.000000000002026297D0/
      DATA B(12,2) /-0.000000000000168524D0/
      DATA B(13,2) / 0.000000000000013885D0/
      DATA B(14,2) /-0.000000000000001135D0/
      DATA B(15,2) / 0.000000000000000092D0/
      DATA B(16,2) /-0.000000000000000007D0/
      DATA B(17,2) / 0.000000000000000001D0/

      DATA B( 0,3) / 0.076012604655110384D0/
      DATA B( 1,3) /-0.036257186481828739D0/
      DATA B( 2,3) / 0.005797202338937002D0/
      DATA B( 3,3) /-0.000769646513610481D0/
      DATA B( 4,3) / 0.000091492082189884D0/
      DATA B( 5,3) /-0.000010097131488364D0/
      DATA B( 6,3) / 0.000001055777442831D0/
      DATA B( 7,3) /-0.000000105929577481D0/
      DATA B( 8,3) / 0.000000010285494201D0/
      DATA B( 9,3) /-0.000000000972314310D0/
      DATA B(10,3) / 0.000000000089884635D0/
      DATA B(11,3) /-0.000000000008153171D0/
      DATA B(12,3) / 0.000000000000727572D0/
      DATA B(13,3) /-0.000000000000064010D0/
      DATA B(14,3) / 0.000000000000005562D0/
      DATA B(15,3) /-0.000000000000000478D0/
      DATA B(16,3) / 0.000000000000000041D0/
      DATA B(17,3) /-0.000000000000000003D0/

      DATA B( 0,4) /-0.077234724056994793D0/
      DATA B( 1,4) / 0.047867163451599467D0/
      DATA B( 2,4) /-0.009440702186674632D0/
      DATA B( 3,4) / 0.001489544740103448D0/
      DATA B( 4,4) /-0.000204944023348860D0/
      DATA B( 5,4) / 0.000025671425065297D0/
      DATA B( 6,4) /-0.000003001393581584D0/
      DATA B( 7,4) / 0.000000332766437356D0/
      DATA B( 8,4) /-0.000000035365412111D0/
      DATA B( 9,4) / 0.000000003630622927D0/
      DATA B(10,4) /-0.000000000362096951D0/
      DATA B(11,4) / 0.000000000035237509D0/
      DATA B(12,4) /-0.000000000003357440D0/
      DATA B(13,4) / 0.000000000000314068D0/
      DATA B(14,4) /-0.000000000000028908D0/
      DATA B(15,4) / 0.000000000000002623D0/
      DATA B(16,4) /-0.000000000000000235D0/
      DATA B(17,4) / 0.000000000000000021D0/
      DATA B(18,4) /-0.000000000000000002D0/

      DATA B( 0,5) / 0.104933034459278632D0/
      DATA B( 1,5) /-0.078877901652793557D0/
      DATA B( 2,5) / 0.018397415112159397D0/
      DATA B( 3,5) /-0.003352284159396504D0/
      DATA B( 4,5) / 0.000522878230918016D0/
      DATA B( 5,5) /-0.000073179785814740D0/
      DATA B( 6,5) / 0.000009449729612085D0/
      DATA B( 7,5) /-0.000001146339856723D0/
      DATA B( 8,5) / 0.000000132269366108D0/
      DATA B( 9,5) /-0.000000014646669180D0/
      DATA B(10,5) / 0.000000001566940742D0/
      DATA B(11,5) /-0.000000000162791157D0/
      DATA B(12,5) / 0.000000000016490345D0/
      DATA B(13,5) /-0.000000000001634028D0/
      DATA B(14,5) / 0.000000000000158807D0/
      DATA B(15,5) /-0.000000000000015171D0/
      DATA B(16,5) / 0.000000000000001427D0/
      DATA B(17,5) /-0.000000000000000132D0/
      DATA B(18,5) / 0.000000000000000012D0/
      DATA B(19,5) /-0.000000000000000001D0/

      DATA B( 0,6) /-0.178617622142502753D0/
      DATA B( 1,6) / 0.155776462200520579D0/
      DATA B( 2,6) /-0.041723637673831277D0/
      DATA B( 3,6) / 0.008597141303245400D0/
      DATA B( 4,6) /-0.001496227761073229D0/
      DATA B( 5,6) / 0.000231089608557137D0/
      DATA B( 6,6) /-0.000032632044778436D0/
      DATA B( 7,6) / 0.000004296097867090D0/
      DATA B( 8,6) /-0.000000534528790204D0/
      DATA B( 9,6) / 0.000000063478151644D0/
      DATA B(10,6) /-0.000000007248699714D0/
      DATA B(11,6) / 0.000000000800521979D0/
      DATA B(12,6) /-0.000000000085888793D0/
      DATA B(13,6) / 0.000000000008985442D0/
      DATA B(14,6) /-0.000000000000919356D0/
      DATA B(15,6) / 0.000000000000092225D0/
      DATA B(16,6) /-0.000000000000009090D0/
      DATA B(17,6) / 0.000000000000000882D0/
      DATA B(18,6) /-0.000000000000000084D0/
      DATA B(19,6) / 0.000000000000000008D0/
      DATA B(20,6) /-0.000000000000000001D0/

      DATA C(1,1) / 1.66666666666666667D-1/
      DATA C(2,1) /-3.33333333333333333D-2/
      DATA C(3,1) / 2.38095238095238095D-2/
      DATA C(4,1) /-3.33333333333333333D-2/
      DATA C(5,1) / 7.57575757575757576D-2/
      DATA C(6,1) /-2.53113553113553114D-1/
      DATA C(7,1) / 1.16666666666666667D0/

      DATA C(1,2) / 5.00000000000000000D-1/
      DATA C(2,2) /-1.66666666666666667D-1/
      DATA C(3,2) / 1.66666666666666667D-1/
      DATA C(4,2) /-3.00000000000000000D-1/
      DATA C(5,2) / 8.33333333333333333D-1/
      DATA C(6,2) /-3.29047619047619048D0/
      DATA C(7,2) / 1.75000000000000000D1/

      DATA C(1,3) / 2.00000000000000000D0/
      DATA C(2,3) /-1.00000000000000000D0/
      DATA C(3,3) / 1.33333333333333333D0/
      DATA C(4,3) /-3.00000000000000000D0/
      DATA C(5,3) / 1.00000000000000000D+1/
      DATA C(6,3) /-4.60666666666666667D+1/
      DATA C(7,3) / 2.80000000000000000D+2/

      DATA (C(J,4),J=1,7) /10,-7,12,-33,130,-691,4760/
      DATA (C(J,5),J=1,7) /60,-56,120,-396,1820,-11056,85680/
      DATA (C(J,6),J=1,7) /420,-504,1320,-5148,27300,-187952,1627920/

      A=ABS(X)
      V=A
      IX=X-DELTA
      IF(K .LT. 0 .OR. K .GT. 6) THEN
       H=0
       WRITE(ERRTXT,101) K
       CALL MTLPRT(NAME,'C316.1',ERRTXT)
      ELSEIF(ABS(IX-X) .LE. DELTA) THEN
       H=0
       WRITE(ERRTXT,102) X
       CALL MTLPRT(NAME,'C316.2',ERRTXT)
      ELSEIF(K .EQ. 0) THEN
       IF(A .LE. 3) THEN
        S=0
        IF(A .LT. HF) THEN
         S=1/V
         V=V+1
        ENDIF
        AP=P1(7)
        AQ=Q1(7)
        DO 11 I = 6,0,-1
        AP=P1(I)+V*AP
   11   AQ=Q1(I)+V*AQ
        H=(V-X0)*AP/AQ-S
       ELSE
        R=1/V**2
        AP=P2(4)
        AQ=Q2(4)
        DO 12 I = 3,0,-1
        AP=P2(I)+R*AP
   12   AQ=Q2(I)+R*AQ
        H=LOG(V)-HF/V+AP/AQ
       ENDIF
       IF(X .LT. 0) H=H+1/A+PI/TAN(PI*A)
      ELSE
       K1=K+1
       IF(A .LE. 10) THEN
        IF(A .LT. 3) THEN
         S=-1/V**K1
         DO 1 J = 1,2-INT(A)
         V=V+1
    1    S=S-1/V**K1
         V=V+1
        ELSEIF(A .LE. 4) THEN
         S=0
        ELSE
         V=V-1
         S=1/V**K1
         DO 5 J = 1,INT(A)-4
         V=V-1
    5    S=S+1/V**K1
        ENDIF
        H=2*V-7
        ALFA=H+H
        B1=0
        B2=0
        DO 2 J = NB(K),0,-1
        B0=B(J,K)+ALFA*B1-B2
        B2=B1
    2   B1=B0
        H=B0-H*B2+SGF(K)*S
       ELSE
        S=0
        IF(A .LT. 15) THEN
         S=1/V**K1
         DO 3 J = 1,14-INT(A)
         V=V+1
    3    S=S+1/V**K1
         V=V+1
        ENDIF
        R=1/V**2
        P=R*C(7,K)
        DO 4 J = 6,1,-1
    4   P=R*(C(J,K)+P)
        H=((SGF(K-1)-SGN(K)*P)*V-SGH(K))/V**K1-SGF(K)*S
       ENDIF
       IF(X .LT. 0) THEN
        P=PI*A
        IF(K .EQ. 1) THEN
         V=C1/SIN(P)**2
        ELSEIF(K .EQ. 2) THEN
         V=C2*COS(P)/SIN(P)**3
        ELSEIF(K .EQ. 3) THEN
         S=SIN(P)**2
         V=C3*(2*S-3)/S**2
        ELSEIF(K .EQ. 4) THEN
         S=SIN(P)
         V=C4*COS(P)*(S**2-3)/S**5
        ELSEIF(K .EQ. 5) THEN
         S=SIN(P)**2
         V=C5*(15-15*S+2*S**2)/S**3
        ELSEIF(K .EQ. 6) THEN
         S=SIN(P)
         V=C6*COS(P)*(45-30*S**2+2*S**4)/S**7
        ENDIF
        H=SGN(K)*(H+V+SGF(K)/A**K1)
       ENDIF
      ENDIF

      dpsipg=H

      RETURN
  101 FORMAT('K = ',I5,'  (< 0  OR  > 6)')
  102 FORMAT('ARGUMENT EQUALS NON-POSITIVE INTEGER =',1P,E15.6)
      END function dpsipg


      !-- a very abbreviated version of mtlprt
      SUBROUTINE MTLPRT(NAME,ERC,TEXT)
        CHARACTER(len=*) NAME,ERC,TEXT
        WRITE(  0,100) ERC(1:4),NAME,ERC,trim(TEXT)
        stop
100     FORMAT(7X,'***** CERN ',A,1X,A,' ERROR ',A,': ',A)
      END SUBROUTINE MTLPRT

      !----------------------------------
      function tanh(x)
        use types
        real(dp), intent(in) :: x
        real(dp)             :: tanh, expp, expm
        expp = exp(x)
        expm = exp(-x)
        tanh = (expp - expm)/(expp + expm)
      end function tanh

end module special_functions

