
program ppp
  use types; use consts_dp; use qcd
  use conv_objects; use parton_distributions; use convolution
  use evolution
  use alfas_server
  implicit none
  type(as_handle)  :: ash
  type(grid_def)   :: gd
  real(dp), pointer :: q1(:,:)
  real(dp), pointer :: dqLL(:,:), dqNL(:,:), dqCTEQ(:,:)
  real(dp), pointer :: q(:)
  integer :: i, id, ipdf
  integer :: n = 300
  real(dp) :: f, y, dy, Q2, as2pi, res,x
  type(PMat) :: PLO, PNLO

  
!!$  call mh_sum_rules
!!$  stop
  dy = 0.05_dp
  call conv_InitGridDef(gd,dy,5.0_dp)
  call cobj_InitSplitLO(gd,PLO)
  call cobj_InitSplitNLO(gd,PNLO)


  Q2 = 100.0_dp**2; 
  ipdf = pdf_CTEQ5M
  call pdf_InitDist(gd,q1,     sqrt(Q2),pdf_ZERO)
  call pdf_InitDist(gd,dqCTEQ, sqrt(Q2),pdf_ZERO)
  call pdf_InitDist(gd,dqLL,   sqrt(Q2),pdf_ZERO)
  call pdf_InitDist(gd,dqNL,   sqrt(Q2),pdf_ZERO)



!!$  call as_init(ash, alfas=0.1254_dp, nloop=1)
!!$  open(unit=10,file='3lres')

  call as_init(ash, alfas=0.1119_dp, nloop=2)
  open(unit=10,file='3mres')

  do i = 0, 100
     read(10,*) x, q1(i,1), q1(i,0), dqC(TEQ(i,1), dqCTEQ(i,0)
  end do
  
  as2pi = as_value(ash,sqrt(Q2))/twopi
  write(0,*) as2pi * twopi
  dqLL = (PLO .conv. q1)
  dqNL = dqLL + as2pi * (PNLO .conv. q1)

  id=1

  write(0,*) conv_momGridQuant(gd, dqCTEQ(:,id) - dqNL(:,id), one)

  call conv_PrintGridQuant(gd,q1(:,id),dqLL(:,id),dqNL(:,id),&
       & dqCTEQ(:,id))

end program ppp
